
       code   segment
               assume  cs:code
               org     0100h

start:
	pushf
	xor     ax,ax
	push    ax
	popf
	pushf
	pop     ax
	and     ax,0f000h
	cmp     ax,0f000h
	je      i_8x
	push    sp
	pop     bx
	cmp     bx,sp
	jne     i_18x
	mov     ax,0f000h
	push    ax
	popf
	pushf
	pop     ax
	and     ax,0f000h
	je      i_286

	mov     dx,offset p386
	jmp     short processor_return
i_286:
	mov     dx,offset p286
	jmp     short processor_return
i_18x:
	mov     dx,offset p18x
	jmp     short processor_return

i_8x:
	mov     dx,offset p8x

processor_return:
	popf
	mov     ax,0900h
	int     21h
	push    es
	mov     ax,0f000h
	push    ax
	pop     es
	mov     bx,0fffeh
	mov     ah,es:[bx]
	cmp     ah,255
	jz      is_pc
	cmp     ah,254
	jz      is_xt
	cmp     ah,253
	jz      is_jr
	cmp     ah,252
	jz      is_at
	mov     dx,offset ibm_not
	jmp     short print_model
is_pc:  mov     dx,offset ibm_pc
	jmp     short print_model
is_xt:  mov     dx,offset ibm_xt
	jmp     short print_model
is_jr:  mov     dx,offset ibm_jr
	jmp     short print_model
is_at:  mov     dx,offset ibm_at
print_model:
	mov     ax,0900h
	int     21h
	pop     es
	int     20h


p8x:            db      0dh,0ah,"Processor is Intel 8086/88",0dh,0ah,"$"
p18x:           db      0dh,0ah,"Processor is Intel 80186/80188.",0dh,0ah,"$"
p286:           db      0dh,0ah,"Processor is Intel 80286.",0dh,0ah,"$"
p386:           db      0dh,0ah,"Processor is Intel 80386.",0dh,0ah,"$"

ibm_not:        db      "Unrecognized computer.",0dh,0ah,"$"
ibm_pc:         db      "IBM PC.",0dh,0ah,"$"
ibm_xt:         db      "IBM PC/XT or Portable PC.",0dh,0ah,"$"
ibm_jr:         db      "IBM PCjr.",0dh,0ah,"$"
ibm_at:         db      "IBM PC/AT.",0dh,0ah,"$"

code    ends

        end    start
