
code    segment


        assume  cs:code,ds:code


        org     0100h


setmode proc    far

        mov     dx,offset Pg_Msg    ;display message
        mov     ah,09
        int     21h

        mov     dx,Port_Num         ;load DX with com1:
        mov     ah,03
        int     14h

        test    ah,80h              ;check time out status
        jnz     Port_Not_Ready

        mov     cx,Nos_Bytes        ;load start values
        mov     bx,offset Code_Table

send:   mov     dx,Port_Num         ;send byte to com1
        mov     al,[bx]
        mov     ah,01
        int     14h

        test    ah,80h              ;check timeout status
        jnz     Port_Not_Ready

        inc     bx                  ;increment and loop
        loop    send

        int     20h                 ;return to dos when ready


Port_Not_Ready:
        mov     dx,offset Err_Msg   ;timeout !!
        mov     ah,09
        int     21h

        int     20h


Pg_Msg          db      0ah,0dh,"Setmode Ver 0.10"
                db      0ah,0dh," 1986"
                db      0ah,0dh,"$"

Err_Msg         db      0ah,0dh,"Printer/Modem not ready !",0ah,0dh,"$"

Nos_Bytes       dw      38

Code_Table      db      0ah,0dh,"        TEST AV LASERSETUP PROGRAM",0ch

Port_Num        dw      0000h

;NOTE           COM1=0000h, COM2=0001h

setmode endp


code    ends


        end     setmode

