	Name    DISK

	Public  DISKGet,DISKPut,DISKFormat

	Title   DISK.ASM
;***************************************************************************
;       FAR VERSION OF MODULE                                        900311
;***************************************************************************

	extrn   STRINGADDRESS:far
	extrn   STRINGLENGTH:far

;***************************************************************************
;       Data Area
;***************************************************************************

	data    segment word    public  'data'

	fad             db 0

	Stringlen       db ?

	strOff  dw      ?               ;string offset  BC7
	strSeg  dw      ?               ;string segment BC7
	StrLen  dw      ?               ;string length  BC7

	data    ends
	dgroup  group   data


;***************************************************************************
;       Code Area
;***************************************************************************

	code    segment byte    public  'code'
		assume  cs:code,ds:dgroup

;----------------------------------------------------------------------------
; DiskGet
;----------------------------------------------------------------------------
	DiskGet           proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di
		push    ds
		push    es

		mov     ax,[bp+06]              ;get string address
		push    ax
		call    STRINGADDRESS
		mov     strOff,ax
		mov     strSeg,dx

		mov     bx,[bp+08]              ;get drive
		mov     bl,[bx]

		mov     ah,44h
		mov     al,0dh
		mov     ch,8
		mov     cl,60h
		mov     dx,strOff
		mov     si,strSeg
		push    ds
		push    si
		pop     ds

		int     21h

		pop     ds
		jc      error0
		xor     ax,ax
error0:

		pop     es
		pop     ds
		pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret     04                      ;return 2xParameters
	DiskGet          endp
;----------------------------------------------------------------------------
; DiskPut
;----------------------------------------------------------------------------
	DiskPut         proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di
		push    ds
		push    es

		mov     ax,[bp+06]              ;get string address
		push    ax
		call    STRINGADDRESS
		mov     strOff,ax
		mov     strSeg,dx

		mov     bx,[bp+08]              ;get drive
		mov     bl,[bx]

		mov     ah,44h
		mov     al,0dh
		mov     ch,8
		mov     cl,40h
		mov     dx,strOff
		mov     si,strSeg
		push    ds
		push    si
		pop     ds

		int     21h
		pop     ds
		jc      error1
		xor     ax,ax
error1:
		pop     es
		pop     ds
		pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret     04                      ;return 2xParameters
	DiskPut         endp

;----------------------------------------------------------------------------
; DiskFormat
;----------------------------------------------------------------------------
	DiskFormat      proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di
		push    ds
		push    es

		mov     ax,[bp+06]              ;get string address
		push    ax
		call    STRINGADDRESS
		mov     strOff,ax
		mov     strSeg,dx

		mov     bx,[bp+08]              ;get drive
		mov     bl,[bx]

		mov     ah,44h
		mov     al,0dh
		mov     ch,8
		mov     cl,42h
		mov     dx,strOff
		mov     si,strSeg
		push    ds
		push    si
		pop     ds

		int     21h
		pop     ds
		jc      error2
		xor     ax,ax
error2:
		pop     es
		pop     ds
		pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret     04                      ;return 2xParameters
	DiskFormat         endp

	code    ends
		end

