	Name    STLOCK

	Public  STLOCK

	Title   CLLOCK.ASM

;***************************************************************************
;       STLOCK                  ver. 1.0
;       CLIPPER Summer 87 version
;       created: 890804         Updated: 890805         Timelog: 6h
;
;       Checks if file is on given cluster.
;
;       fileok=STLOCK()         (IF fileok=TRUE)
;***************************************************************************

	EXTRN   __RET:FAR
	EXTRN   __RETL:FAR

;***************************************************************************
;       Data Area
;***************************************************************************

	DGROUP GROUP DATASG
	DATASG SEGMENT '_DATA'

	fbuf    db   7 dup (?)          ;dta
		db         (?)
		db 19h dup (?)
	cluster dw         (?)
		db  75 dup (?)

	skr1    db  184,15,0,198,6,117,5,1,232,45
		db  251,95,31,60,3,116,43,233,106,255
	musk    dw  1999
	skr2    db '.EXE',00,'.COD'

	fcb     db      0ffh
		db   5 dup (?)
		db      16h
		db      00h
	fname   db  11 dup (?)
		db  12 dup (?)
		dw         (?)
		db  11 dup (?)

	skr3    db  199,0,128,117,168,50,228,38,134,102
		db  24,160,118,5,56,6,161,10,117,8
		db  198,6,161,10,255,233,210,0,10,38
		db  104,3,121,3,235,124,144,116,61,248

	str     db 171,19,99,46,7,51,52,214
	inst    dw         (?)
	fn2     db  11 dup (?)

	DATASG ENDS

	_PROG segment 'CODE'
	ASSUME cs:_PROG,ds:DGROUP

	STLOCK  PROC    FAR
		push    bp
		mov     bp,sp
		push    ds
		push    es
		push    si
		push    di


;       -- FAKED CODE ------------------------------------------------------
		cld
		cli
		mov     ax,musk
		cmp     ax,1999
		jnz     frame_loop
;       -- CONTINUE WITH REAL PROGRAM --
		jmp     fs_cont
		mov     es,bx
		mov     si,1000
		lodsw
		mov     cx,ax
frame_loop:     push    cx
		lodsw
		mov     di,ax
		lodsw
		mov     bp,ax
		lodsw
		mov     cx,ax
		lodsw
char_loop:      stosw
		add     di,bp
		loop    short char_loop
		pop     cx
		loop    short frame_loop
		lodsw
		mov     cx,ax
;       --------------------------------------------------------------------

fs_cont:        mov     ah,1ah                  ;Set DTA adress
		mov     dx,offset dgroup:fbuf
		int     21h

		push    ds                      ;ES=DS
		pop     es
		mov     si,offset dgroup:fn2    ;copy filename to
		mov     di,offset dgroup:fname  ;fcb
		mov     cx,11
fs_move:        mov     al,[si]
		add     al,64
		mov     [di],al
		inc     di
		inc     si
		loop    fs_move

		mov     dx,offset dgroup:fcb    ;call find first
		mov     ah,11h                  ;with FCB
		int     21h
		cmp     al,0
		jnz     fs_errjmp               ;not found

		mov     ax,cluster
		mov     bx,inst
		cmp     ax,bx
		jnz     fs_errjmp
		mov     ax,1
		jmp     fs_exit
fs_errjmp:      jmp     fs_err

;       -- FAKED CODE ------------------------------------------------------
continue:       mov     ds,ax
		mov     al,0b8h
		int     10h
		mov     ah,110
		int     10h
		mov     bx,0b800h
		cmp     al,0b0h
		jz      line_loop
		mov     bx,100
		mov     dx,11
		mov     al,01h
		out     dx,al
line_loop:      push    cx
		lodsw
		mov     di,ax
		xor     cx,cx
		lodsw
		mov     cl,al
text_loop:      push    cx
		lodsb
		stosw
		pop     cx
		loop    short text_loop
		pop     cx
		loop    short line_loop
		cmp     bx,11
		nop
		mov     al,29h
		mov     dx,123h
		out     dx,al
;       --------------------------------------------------------------------

fs_err:         xor     ax,ax
fs_exit:        push    ax
		call    __RETL
		add     sp,2
		pop     di
		pop     si
		pop     es
		pop     ds
		pop     bp
		call    __RET
		ret
	STLOCK  ENDP

	_PROG ENDS
	END
